/*
  Doc_Arduino - german Arduino Forum
  Programmed and tested with: Arduino IDE v1.8.13
  07.03.2021
  Provides current bit definitions which are missing in the old header file.
  Forward compatible.
*/

#pragma once

#if defined(__AVR_ATmega4809__)
    // Event System //
    // Zeile 816
    #ifndef EVSYS_GENERATOR_TCB0_CAPT_gc
      constexpr uint8_t EVSYS_GENERATOR_TCB0_CAPT_gc {0xA0};
    #endif
    #ifndef EVSYS_GENERATOR_TCB1_CAPT_gc
      constexpr uint8_t EVSYS_GENERATOR_TCB1_CAPT_gc {0xA2};  
    #endif
    #ifndef EVSYS_GENERATOR_TCB2_CAPT_gc
      constexpr uint8_t EVSYS_GENERATOR_TCB2_CAPT_gc {0xA4};  
    #endif
    #ifndef EVSYS_GENERATOR_TCB3_CAPT_gc
      constexpr uint8_t EVSYS_GENERATOR_TCB3_CAPT_gc {0xA6};  
    #endif
    #ifndef EVSYS_GENERATOR_ADC0_RESRDY_gc
      constexpr uint8_t EVSYS_GENERATOR_ADC0_RESRDY_gc {0x24};  // ADC 0 Result Ready Event
    #endif

    // PORTMUX - Port Multiplexer //
    // Zeile 3905
    // new A...F not 0...5
    #ifndef PORTMUX_EVOUTA_bm
      constexpr uint8_t PORTMUX_EVOUTA_bm {0x01};   // Event Output A bit mask.
    #endif
    #ifndef PORTMUX_EVOUTA_bp
      constexpr uint8_t PORTMUX_EVOUTA_bp {0};      // Event Output A bit position.
    #endif
    #ifndef PORTMUX_EVOUTB_bm
      constexpr uint8_t PORTMUX_EVOUTB_bm {0x02};   // Event Output B bit mask. 
    #endif
    #ifndef PORTMUX_EVOUTB_bp
      constexpr uint8_t PORTMUX_EVOUTB_bp {1};      // Event Output B bit position.
    #endif
    #ifndef PORTMUX_EVOUTC_bm
      constexpr uint8_t PORTMUX_EVOUTC_bm {0x04};   // Event Output C bit mask. 
    #endif
    #ifndef PORTMUX_EVOUTC_bp
      constexpr uint8_t PORTMUX_EVOUTC_bp {2};      // Event Output C bit position. 
    #endif
    #ifndef PORTMUX_EVOUTD_bm
      constexpr uint8_t PORTMUX_EVOUTD_bm {0x08};   // Event Output D bit mask. 
    #endif
    #ifndef PORTMUX_EVOUTD_bp
      constexpr uint8_t PORTMUX_EVOUTD_bp {3};      // Event Output D bit position. 
    #endif
    #ifndef PORTMUX_EVOUTE_bm
      constexpr uint8_t PORTMUX_EVOUTE_bm {0x10};   // Event Output E bit mask. 
    #endif
    #ifndef PORTMUX_EVOUTE_bp
      constexpr uint8_t PORTMUX_EVOUTE_bp {4};      // Event Output E bit position. 
    #endif
    #ifndef PORTMUX_EVOUTF_bm
      constexpr uint8_t PORTMUX_EVOUTF_bm {0x20};   // Event Output F bit mask. 
    #endif
    #ifndef PORTMUX_EVOUTF_bp
      constexpr uint8_t PORTMUX_EVOUTF_bp {5};      // Event Output F bit position. 
    #endif
#else
    #error "This library only support ATmega4809."
#endif

/*
// Secrets //
// Zeile 326
#ifndef BOD_LVL_BODLEVEL1_gc
  constexpr uint8_t BOD_LVL_BODLEVEL1_gc {0x01};  // 2.1 V
#endif
#ifndef BOD_LVL_BODLEVEL3_gc
  constexpr uint8_t BOD_LVL_BODLEVEL3_gc {0x03};  // 2.9 V
#endif
#ifndef BOD_LVL_BODLEVEL4_gc
  constexpr uint8_t BOD_LVL_BODLEVEL4_gc {0x04};  // 3.3 V
#endif
#ifndef BOD_LVL_BODLEVEL5_gc
  constexpr uint8_t BOD_LVL_BODLEVEL5_gc {0x05};  // 3.7 V 
#endif
#ifndef BOD_LVL_BODLEVEL6_gc
  constexpr uint8_t BOD_LVL_BODLEVEL6_gc {0x06};  // 4.0 V 
#endif
*/

/*
// CRCSCAN.CTRLB  bit masks and bit positions //
// Zeile 3511
#define CRCSCAN_MODE_gm  0x30;    // CRC Flash Access Mode group mask. 
#define CRCSCAN_MODE_gp  4;       // CRC Flash Access Mode group position. 
#define CRCSCAN_MODE0_bm (1<<4);  // CRC Flash Access Mode bit 0 mask. 
#define CRCSCAN_MODE0_bp 4;       // CRC Flash Access Mode bit 0 position. 
#define CRCSCAN_MODE1_bm (1<<5);  // CRC Flash Access Mode bit 1 mask. 
#define CRCSCAN_MODE1_bp 5;       // CRC Flash Access Mode bit 1 position. 


// CRC Flash Access Mode select //
// Zeile 695
typedef enum CRCSCAN_MODE_enum
{
  CRCSCAN_MODE_PRIORITY_gc   = (0x00<<4);  // Priority to flash 
  CRCSCAN_MODE_RESERVED_gc   = (0x01<<4);  // Reserved 
  CRCSCAN_MODE_BACKGROUND_gc = (0x02<<4);  // Lowest priority to flash
  CRCSCAN_MODE_CONTINUOUS_gc = (0x03<<4);  // Continuous checks in background
} CRCSCAN_MODE_t;
*/