/*
  Doc_Arduino - german Arduino Forum
  Arduino IDE v1.8.13
  Arduino Nano Every
  02.03.2021
  License: GNU GPLv3
  
  Methodentest.
  Es wird nur ein von 4 TCBn Timer behandelt. Dabei werden alle verfügbaren Methoden getestet.
*/

#include <megaAVR0TCBn.h>
#include <utilities.h>

TCB <0> tcb0;

void setup (void)
{
  Serial.begin(250000);
  Serial.println(F("\nStart #### #### #### ####"));

  byte *ptr = nullptr;

  Serial.print(F("CTRLA    ")); *ptr = TCB0_CTRLA; formatBINln(Serial, *ptr, true); 
  Serial.print(F("CTRLB    ")); *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true); 
  Serial.print(F("EVCTRL   ")); *ptr = TCB0_EVCTRL; formatBINln(Serial, *ptr, true);  
  Serial.print(F("INTCTRL  ")); *ptr = TCB0_INTCTRL; formatBINln(Serial, *ptr, true);  
  Serial.print(F("INTFLAGS ")); *ptr = TCB0_INTFLAGS; formatBINln(Serial, *ptr, true); 
  Serial.print(F("STATUS   ")); *ptr = TCB0_STATUS; formatBINln(Serial, *ptr, true); 
  
  Serial.println(F("\nRESET\n")); tcb0.reset();
  
  Serial.print(F("CTRLA    ")); *ptr = TCB0_CTRLA; formatBINln(Serial, *ptr, true); 
  Serial.print(F("CTRLB    ")); *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true); 
  Serial.print(F("EVCTRL   ")); *ptr = TCB0_EVCTRL; formatBINln(Serial, *ptr, true);  
  Serial.print(F("INTCTRL  ")); *ptr = TCB0_INTCTRL; formatBINln(Serial, *ptr, true);  
  Serial.print(F("INTFLAGS ")); *ptr = TCB0_INTFLAGS; formatBINln(Serial, *ptr, true); 
  Serial.print(F("STATUS   ")); *ptr = TCB0_STATUS; formatBINln(Serial, *ptr, true); 
  Serial.println();
    
  Serial.print(F("enable             ")); tcb0.enable();           *ptr = TCB0_CTRLA; formatBINln(Serial, *ptr, true);  
  Serial.print(F("isRunning          ")); tcb0.isRunning();        *ptr = TCB0_STATUS; formatBINln(Serial, *ptr, true); 
  Serial.print(F("disable            ")); tcb0.disable();          *ptr = TCB0_CTRLA; formatBINln(Serial, *ptr, true);    
  Serial.print(F("DIV1               ")); tcb0.setCLKDIV1();       *ptr = TCB0_CTRLA; formatBINln(Serial, *ptr, true);  
  Serial.print(F("DIV2               ")); tcb0.setCLKDIV2();       *ptr = TCB0_CTRLA; formatBINln(Serial, *ptr, true);  
  Serial.print(F("DIVTCA             ")); tcb0.setCLKTCA();        *ptr = TCB0_CTRLA; formatBINln(Serial, *ptr, true);  
  Serial.print(F("enableSYNCUPD      ")); tcb0.enableSYNCUPD();    *ptr = TCB0_CTRLA; formatBINln(Serial, *ptr, true);   
  Serial.print(F("disableSYNCUPD     ")); tcb0.disableSYNCUPD();   *ptr = TCB0_CTRLA; formatBINln(Serial, *ptr, true);  
  Serial.print(F("enableRUNSTDBY     ")); tcb0.enableRUNSTDBY();   *ptr = TCB0_CTRLA; formatBINln(Serial, *ptr, true);  
  Serial.print(F("disableRUNSTDBY    ")); tcb0.disableRUNSTDBY();  *ptr = TCB0_CTRLA; formatBINln(Serial, *ptr, true);  
   
  Serial.print(F("INT                ")); tcb0.setModeINT();       *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);  
  Serial.print(F("TIMEOUT            ")); tcb0.setModeTIMEOUT();   *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);  
  Serial.print(F("CAPT               ")); tcb0.setModeCAPT();      *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);  
  Serial.print(F("FRQ                ")); tcb0.setModeFRQ();       *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);  
  Serial.print(F("PW                 ")); tcb0.setModePW();        *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);    
  Serial.print(F("FRQPW              ")); tcb0.setModeFRQPW();     *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);    
  Serial.print(F("SINGLE             ")); tcb0.setModeSINGLE();    *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);   
  Serial.print(F("PWM8               ")); tcb0.setModePWM8();      *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);     
  Serial.print(F("enableCCMPEN       ")); tcb0.enableCCMPEN();     *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);  
  Serial.print(F("disableCCMPEN      ")); tcb0.disableCCMPEN();    *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);   
  Serial.print(F("enableCCMPINIT     ")); tcb0.enableCCMPINIT();   *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);   
  Serial.print(F("disableCCMPINIT    ")); tcb0.disableCCMPINIT();  *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);  
  Serial.print(F("enableASYNC        ")); tcb0.enableASYNC();      *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);  
  Serial.print(F("disableASYNC       ")); tcb0.disableASYNC();     *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);  

  Serial.print(F("enableEventInput   ")); tcb0.enableEventInput();    *ptr = TCB0_EVCTRL; formatBINln(Serial, *ptr, true);   
  Serial.print(F("disableEventInput  ")); tcb0.disableEventInput();   *ptr = TCB0_EVCTRL; formatBINln(Serial, *ptr, true);   
  Serial.print(F("enableNoiseFilter  ")); tcb0.enableNoiseFilter();   *ptr = TCB0_EVCTRL; formatBINln(Serial, *ptr, true);    
  Serial.print(F("disableNoiseFilter ")); tcb0.disableNoiseFilter();  *ptr = TCB0_EVCTRL; formatBINln(Serial, *ptr, true);   
  Serial.print(F("enableEventEdge    ")); tcb0.enableEventEdge();     *ptr = TCB0_EVCTRL; formatBINln(Serial, *ptr, true);    
  Serial.print(F("disableEventEdge   ")); tcb0.disableEventEdge();    *ptr = TCB0_EVCTRL; formatBINln(Serial, *ptr, true);  
  
  Serial.print(F("enableCAPTInt.     ")); tcb0.enableCAPTInterrupt();   *ptr = TCB0_INTCTRL; formatBINln(Serial, *ptr, true);    
  Serial.print(F("disableCAPTInt.    ")); tcb0.disableCAPTInterrupt();  *ptr = TCB0_INTCTRL; formatBINln(Serial, *ptr, true); 
    
  Serial.print(F("deleteFlagCAPT     ")); tcb0.deleteFlagCAPT();      *ptr = TCB0_INTFLAGS; formatBINln(Serial, *ptr, true);    

  tcb0.reset();
  Serial.print(F("INT                ")); tcb0.setModeINT();          *ptr = TCB0_CTRLB; formatBINln(Serial, *ptr, true);  
  Serial.print(F("setCounter 34569   ")); tcb0.setCounter(34569);     Serial.println(tcb0.readCounter() );
  Serial.print(F("setCompare 12348   ")); tcb0.setCompare(12348);     Serial.println(tcb0.readCompare() );
}

void loop (void)
{
}